<template>
  <div>
    <button class="btn btn-primary capsule" @click="showModal()">
      New
      <i class="fas fa-plus"></i>
    </button>
    <b-modal
      id="modal1"
      hide-footer
      hide-header
      centered
      ref="thisModal"
      class="border-0"
      size="600"
    >
      <div class="container">
        <div class="row mb-2">
          <div class="col-md-6">
            <h5>Create Content</h5>
          </div>
          <div class="col-md-6">
            <img
              :src="asset(`images/ui_elements/ic_close.png`)"
              style="width:25px"
              @click="hideModal"
              class="float-right"
            >
          </div>
        </div>
        <div class="row">
          <div class="col-md-12">
            <form class="form-material" @submit.prevent="submitForm">
              <div class="form-group">
                <div class="image-container text-center rounded p-4">
                  <div class="empty" v-if="content.image_url=='' || content.image_url==null">
                    <i class="fa fa-plus" style="color: #9ba6b3"></i>
                    <span>Add image</span>
                  </div>
                  <img :src="content.image_url" v-else>
                  <input type="file" ref="files" @change="handleFilesUpload" class="form-control">
                </div>
              </div>
              <div class="form-group">
                <label>Title</label>
                <input
                  type="title"
                  class="form-control"
                  name="title"
                  v-validate="'required'"
                  placeholder="Enter Title"
                  v-model="content.title"
                >
                <small class="text-danger">{{ errors.first('title') }}</small>
              </div>
              <div class="form-group">
                <label>Description</label>
                <textarea
                  v-model="content.description"
                  name="description"
                  v-validate="'required'"
                  class="form-control"
                ></textarea>
                <small class="text-danger">{{ errors.first('description') }}</small>
              </div>

              <div class="form-group">
                <label>Category</label>
                <select name="gender" class="form-control" v-model="content.category">
                  <option value="tips">Tips</option>
                  <option value="info">Info</option>
                </select>
              </div>

              <div class="form-group row">
                <div class="col-md-12">
                  <label>Button</label>
                </div>
                <div class="col-md-6">
                  <small class="d-block text-muted">Button Label</small>
                  <input
                    type="text"
                    class="form-control"
                    name="btn-label"
                    v-model="content.buttonLabel"
                    placeholder="button label"
                  >
                </div>
                <div class="col-md-6">
                  <small class="d-block text-muted">Button Type</small>
                  
                  <select name="btn-type" class="form-control" v-model="content.buttonType">
                    <option value="postback">Postback</option>
                    <option value="uri">URI</option>
                    <option value="activity">Activity</option>
                    <option value="detail">Detail</option>
                  </select>
                </div>
              </div>

              <div class="form-group row">
                <div class="col-md-12">
                  <label>Data</label>
                </div>
                <div class="col-md-12">
                  <!-- <small class="d-block text-muted">Data</small> -->
                  <input
                    type="text"
                    class="form-control"
                    name="btn-data"
                    v-model="content.data"
                    placeholder="data"
                  >
                </div>
              </div>
              <button type="submit" class="btn btn-primary form-control capsule">
                <span v-if="loading">
                  Saving
                  <i class="fas fa-circle-notch fa-spin"></i>
                </span>
                <span v-else>Save</span>
              </button>
            </form>
          </div>
        </div>
      </div>
    </b-modal>
  </div>
</template>
<script>
import EventBus from "@/EventBus.js";
import * as httpHelper from "@/helpers/httpHelper";

export default {
  data() {
    return {
      loading: false,
      content: {
        title: null,
        category: "tips",
        description: null,
        buttonType: "postback",
        buttonLabel: null,
        data: null,
        image_url: null
      },
      files: ""
    };
  },
  props: ["user"],
  methods: {
    hideModal() {
      this.$refs.thisModal.hide();
    },
    showModal() {
      this.resetForm();
      this.$emit("show");
      this.$refs.thisModal.show();
    },
    resetForm() {
      this.content.title = this.content.description = this.content.buttonLabel = this.content.image_url = null;
      this.content.category = "tips";
      this.content.buttonType = "postback";
      this.content.data = null;
    },
    handleFilesUpload(event) {
      this.files = event.target.files;
      this.submitFiles();
    },
    submitFiles() {
      let formData = new FormData();
      let file = this.files[0];

      formData.append("image", file);

      this.$axios
        .post(
          "api/" +
            this.$store.getters.appId.hashed +
            "/app-content/upload-image",
          formData
        )
        .then(response => {
          this.content.image_url = response.data.image_url;
        });
    },

    async submitForm() {
      let validated = await this.$validator.validateAll();

      if (validated) {
        try {
          this.loading = true;
          let response = await this.$axios.post(
            process.env.MIX_APP_URL +
              `/api/${this.$store.getters.appId.hashed}/app-content`,
            { ...this.content, image_url: this.content.image_url }
          );

          this.hideModal();
          EventBus.$emit("refreshTable");
          httpHelper.successToast(this, response.data.message);
        } catch (error) {
          httpHelper.errorToast(this, error);
        }
      } else {
        // this.$refs.lennaModal.show('alert','Sorry','You must correct your form first')
      }
      this.loading = false;
    }
  }
};
</script>
<style lang="scss" scoped>
.nav-link.active {
  background: #dadada !important;
  color: #1d68a7;
}
.tab-content {
  word-wrap: break-word;
}
.image-container {
  background: #e8e8e8;
  max-height: 400px;
  & input {
    opacity: 0 !important;
    height: 100%;
    position: absolute;
    top: 0;
  }
  & img {
    max-height: 250px;
  }
}
</style>